#define min(a,b) (a<b?a:b)

#define FILTER_OPENCCL 	0x00012345
#define TIMEOUT_CONNECT	500  //time enough for remote side to call an Open-MX primitive

#define ALL_EXCEPT_SBTG	0xFFFFFFFF00000000
#define ALL_BITS		0xFFFFFFFFFFFFFFFF
#define TAG_REQUEST		0x0000000100000000
#define TAG_REPLY 		0x0000000200000000
#define TAG_DATA_PACKET	0x8000000000000000

//#define MAX_REQ_PACKET_SIZE		1024
//rufino, 2012-11-10
#define MAX_REQ_PACKET_SIZE		8192
#define MAX_NUM_PLATFORMS 		4
#define MAX_PARAM_VALUE_SIZE	128
#define MAX_NUM_DEVICES			4
#define MAX_NUM_PROPERTIES		5
#define MAX_NUM_EVENTS			4
#define MAX_OMX_PACKET_SIZE		131072
#define MAX_NUM_LENGTHS			4
//#define MAX_STRINGS_SIZE		1024
//rufino, 2012-11-10
#define MAX_STRINGS_SIZE		8192
#define MAX_OPTIONS_SIZE		16
#define MAX_KERNEL_NAME_SIZE	32
#define MAX_ARG_VALUE_SIZE		64
#define MAX_NUM_WORK_DIMS		4

#define MAX_NUM_THREADS			1

#define CL_PLATFORM_HOSTNAME	0x000


omx_endpoint_t _ccl_local_endpoint;


void _ccl_perror_and_exit(char *str){
	perror(str);
	exit(1);
}


void _ccl_omx_send_packet(void *data, size_t length, omx_endpoint_addr_t addr, uint64_t tag){
	uint32_t result;
	omx_request_t request;
	omx_status_t status;

	if(omx_issend(_ccl_local_endpoint, data, length, addr, tag, NULL, &request))
		_ccl_perror_and_exit("omx_issend");
	if(omx_wait(_ccl_local_endpoint, &request, &status, &result, OMX_TIMEOUT_INFINITE))
		_ccl_perror_and_exit("omx_wait");
}


void _ccl_omx_recv_packet(void *data, size_t max_length, uint64_t tag, uint64_t mask, omx_status_t *status){
	uint32_t result;
	omx_request_t request;
	omx_status_t _status, *__status;

	__status = (status == NULL) ? &_status : status;
	if(omx_irecv(_ccl_local_endpoint, data, max_length, tag, mask, NULL, &request) != OMX_SUCCESS)
		_ccl_perror_and_exit("omx_irecv");
	if(omx_wait(_ccl_local_endpoint, &request, __status, &result, OMX_TIMEOUT_INFINITE) != OMX_SUCCESS)
		_ccl_perror_and_exit("omx_wait");
}
